﻿#Region "FileHeader"
#If False Then
_Dgv_VisibleChanged()-Initialisierung ist ziemlich hacky. Das generiert für DgvComboColumns nämlich unsichtbare ExpressionColumns an die DataTable dran, zum Werte-Abruf übergeordneter DataTables.
Wenn man dann einen Filter oder eine Sortierung entsprechend des DGVColumn-HeaderTextes festlegt, dann wird nicht der DgvColumn.DatapropertyName genommen, sondern die ExpressionColumn. So sortiert es textuell, und man kann mit Text-Vergleich-Filtern arbeiten, auch wenn die dgvColumn ein Integer-FK ist.
#End If '-- Options, Imports
Imports System.ComponentModel
Imports System.Text.RegularExpressions
#End Region 'FileHeader

Public Class uclCheckedText

	Public Enum Mode : Sort : Filter : Filter_NoDisplayOnStringEmpty : End Enum

	Private WithEvents _Dgv As DataGridView
	Private _rgxWord As New Regex("\b\w+\b", RegexOptions.IgnoreCase)
	Private _dicColInfos As New Dictionary(Of String, Tuple(Of DataGridViewColumn, String)) ' map HeaderText to Sort-/Filter-PropertyName

	Public Sub New()
		InitializeComponent()
		If NotifyPropertyChanged.IsInDesignMode Then Return
		AddHandler ckApply.CheckStateChanged, Sub(s, e) ApplyChoice()
		AddHandler txtText.TextChanged, Sub(s, e)
													  ' bei TextChanged ggfs. Ändern des CheckStates
													  If ckApply.Checked Then ckApply.CheckState = CheckState.Indeterminate
												  End Sub
	End Sub

	Private Sub ckApplyFilter_Click(sender As Object, e As EventArgs) Handles ckApply.Click
		' bei Klick 3-wertiges Ändern des CheckStates
		Select Case ckApply.CheckState
			Case CheckState.Checked : ckApply.CheckState = CheckState.Unchecked
			Case CheckState.Unchecked, CheckState.Indeterminate : ckApply.CheckState = CheckState.Checked
		End Select
	End Sub

	Public Sub ApplyChoice()
		'wenn die Checkbox gecheckt, wird ApplyAction ausgeführt, wenn geuncheckt abgeschaltet, bei Indeterminate bleibts wies war
		Select Case ckApply.CheckState
			Case CheckState.Unchecked : ApplyAction("")
			Case CheckState.Indeterminate
			Case CheckState.Checked
				Try
					ApplyAction(txtText.Text)
				Catch ex As Exception
					Msg(ex.Message)
					ckApply.CheckState = CheckState.Indeterminate
				End Try
		End Select
	End Sub

	Private Sub ApplyAction(s As String)
		'Apply s for Sort or Filter, on or off
		Dim bs = DirectCast(_Dgv.DataSource, BindingSource)
		If s = "" Then
			Select Case ActionMode
				Case Mode.Sort : bs.Sort = "" : _Dgv.Attach.DrawGroupLines(False)
				Case Mode.Filter : bs.Filter = ""
				Case Mode.Filter_NoDisplayOnStringEmpty : bs.Filter = "1 = 2"
			End Select
			Return
		End If
		Dim affectedCols As New List(Of DataGridViewColumn)
		Dim evaluate As MatchEvaluator = Function(mt)
														'Vorkommen eines dgvCol.Headertext durch DataPropertyName ersetzen, dgvCol merken
														Dim tpl = _dicColInfos.GetOrDefault(mt.Value)
														If tpl.Null Then Return mt.Value
														affectedCols.Add(tpl.Item1)
														Return tpl.Item2
													End Function
		s = _rgxWord.Replace(s, evaluate)
		Select Case ActionMode
			Case Mode.Sort ' sort-Columns links anordnen + DrawGrouplines
				bs.Sort = s
				For i = 0 To affectedCols.Count - 1
					affectedCols(i).DisplayIndex = i
				Next
				_Dgv.Attach.DrawGroupLines(affectedCols.ToArray())

			Case Mode.Filter, Mode.Filter_NoDisplayOnStringEmpty : bs.Filter = s
		End Select
	End Sub

	Private Sub _Dgv_VisibleChanged(sender As Object, e As EventArgs)
		'Initializing - since _Dgv_VisibleChanged detects _Shown of the underlying Form
		'setup txtText Contextmenu-Items + DataTable-ExpressionColumns + _dicColInfos to make ApplyAction propper work
		RemoveHandler _Dgv.VisibleChanged, AddressOf _Dgv_VisibleChanged
		_ContextMenu.Items.Clear()
		Dim cols = (From col In _Dgv.Columns.Cast(Of DataGridViewColumn) Where col.DataPropertyName <> "" Order By col.HeaderText).ToArray
		_ContextMenu.Items.AddRange(cols.Select(Function(x) New ToolStripMenuItem(x.HeaderText)).ToArray)
		_dicColInfos = cols.ToDictionary(Function(x) x.HeaderText, Function(x) Tuple.Create(x, x.DataPropertyName))
		Dim tb = DirectCast(_Dgv.DataSource, BindingSource).DataTable
		Dim tbCols = tb.Columns.Cast(Of DataColumn).ToArray
		Dim prntRels = tb.ParentRelations.Cast(Of DataRelation).ToArray
		For Each col In cols.OfType(Of DataGridViewComboBoxColumn)
			'DataColumn mit Expression entsprechend der ComboColumn-Verknüpfung von Child- und Parent-Column suchen oder generieren
			Dim tbCol = tb.Columns(col.DataPropertyName)
			If tbCol.DataType Is GetType(String) Then Continue For
			Dim rl = prntRels.FirstOrDefault(Function(x) x.ChildColumns(0) Is tbCol)
			If rl.Null Then Continue For
			Dim expr = $"Parent({rl.RelationName}).{col.DisplayMember}"
			tbCol = tbCols.FirstOrDefault(Function(x) x.Expression.Equals(expr, StringComparison.OrdinalIgnoreCase))
			If tbCol.Null Then tbCol = tb.Columns.Add($"{col.DataPropertyName}_{col.DisplayMember}", GetType(String), expr)
			_dicColInfos(col.HeaderText) = New Tuple(Of DataGridViewColumn, String)(col, tbCol.ColumnName)
		Next
		ApplyChoice()
	End Sub

	Private Sub _ContextMenu_ItemClicked(sender As Object, e As ToolStripItemClickedEventArgs) Handles _ContextMenu.ItemClicked
		'insert ClickedItem.Text into Text
		Dim i = txtText.SelectionStart
		Dim pre = If(i > 0 AndAlso txtText.Text(i - 1) = " ", "", " ")
		i += txtText.SelectionLength
		Dim post = If(i < txtText.TextLength AndAlso txtText.Text(i) = " ", "", " ")
		txtText.SelectedText = pre & e.ClickedItem.Text & post
	End Sub

	<Category("Behaviour"), DefaultValue(Mode.Sort)>
	Public Property ActionMode() As Mode

	<Category("Behaviour"), DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)>
	Public Property DatagridView() As DataGridView
		Get
			Return _Dgv
		End Get
		Set(ByVal value As DataGridView)
			If _Dgv Is value Then Return
			_Dgv = value
			If Not NotifyPropertyChanged.IsInDesignMode Then AddHandler _Dgv.VisibleChanged, AddressOf _Dgv_VisibleChanged
		End Set
	End Property

	<Browsable(True), DesignerSerializationVisibility(DesignerSerializationVisibility.Visible), DefaultValue("")>
	Public Overrides Property Text As String
		Get
			Return txtText.Text
		End Get
		Set
			txtText.Text = Value
		End Set
	End Property

	<Category("Appearance"), DefaultValue(CheckState.Unchecked)>
	Public Property Checkstate As CheckState
		Get
			Return ckApply.CheckState
		End Get
		Set
			ckApply.CheckState = Value
		End Set
	End Property

	<Category("Appearance"), DefaultValue("Apply")>
	Public Property Caption As String
		Get
			Return ckApply.Text
		End Get
		Set
			ckApply.Text = Value
		End Set
	End Property

	<Category("Appearance"), DefaultValue(True)>
	Public Property MultiLine As Boolean
		Get
			Return txtText.Multiline
		End Get
		Set
			txtText.Multiline = Value
		End Set
	End Property

End Class
